      SUBROUTINE SPHER2 (DRA, DDE, DNRA, DNDE, DXN, DYN)
C
CC  calculates tangential-plane approximation to spherical coord.
C
C************************ FFORM VERSION 1.2 ************ DD-MMM-YY HH:MM
C
CA  author : GIH        date: 11-JUL-1990 16:28 
CU  update : GIH        date: 11-JUL-1990 17:13 
CU  update : EXSAS              date: 03-AUG-1993 19:48
C
CT  status: not tested
C
C   general description:
CG  calculates tangential-plane approximation to spherical coord.
CG  (to transform delta-alpha, delta-delta into delta-x, delta-y
CG  spherical transformation of RA,DEC to use them as planar 
CG  coordinates
C
C   call_var.          type I/O description
CP  IERR                I     O = 0 no error 
CP                              = 3 
CP  DRA                 R8  I   actual right ascension  [rad]
CP  DDE                 R8  I   actual declination      [rad]
CP  DNRA                R8  I   nominal right ascension [rad]
CP  DNSCDE              R8  I   SIN and COS of nominal declination 
CP  DXN                 R8    O residual RA             [rad]
CP  DYN                 R8    O residual DEC            [rad]
C
C   include_block_name          description
CI  R$COMMON:CGENL.CMN          general parameter common block
C
C   routines_called    type     description
CR  HFLAG               R       output flag handling routine
CR  WRFLAG              SR      writes to FLAG output stream
C
C   extensions/system calls     description
CX  
C
C***********************************************************************
C
C   variables   meaning
C
C
      IMPLICIT NONE
C     INCLUDE 'RCOMMON:CGENL.CMN'
C
      DOUBLE PRECISION
     &        DCOSDE, DCOSRA, DDE, DDENEW, DH, DIFFRA, DNRA, DNDE,
     #              DNSDE, DNCDE, DRA, DRANEW, DSINDE, DSINRA, DXN, DYN, 
     #              D1C, D1S, D2C, D2S
      INTEGER     IERR
C     CHARACTER*8   RTNAME
C
      SAVE
C     DATA          RTNAME /'SPHER2'/
C
      IERR = 0
C
C     (in the following, D1S,D2S are buffers containing sines,
C     D1C,D2C are buffers containing cosines the formulas are taken 
C     from subroutine DTRA)
C
          DIFFRA = DRA - DNRA
          DSINRA = DSIN(DIFFRA)
          DCOSRA = DCOS(DIFFRA)
          DSINDE = DSIN(DDE)
          DCOSDE = DCOS(DDE)
          dnsde = dsin(dnde)
          dncde = dcos(dnde)
C
C  residual Alpha DRANEW 
          D1S    =   DSINRA * DCOSDE
          DH     = - DCOSDE * DCOSRA
          D1C    =   DNSDE * DSINDE - DH * DNCDE
          DRANEW =   DATAN2(D1S,D1C)                 
C          
C  residual Delta DDENEW 
          D2S    = DH * DNSDE + DNCDE * DSINDE
          D2C    = DSQRT(1.0D0 - D2S * D2S)
          DDENEW = DATAN2(D2S,D2C)
C
C convert to X,Y in NS-system (antiparllel to RA,DEC)
          DXN     = - DRANEW
          DYN     = - DDENEW
C
      RETURN
      END     
